'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var dispatch = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(action) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!_lodash2.default.isFunction(action) && !_lodash2.default.isPlainObject(action)) {
              error = new Error('unsupported ' + action + ' action type sent to dispatch');
            }

            dispatches.push(createDispatchedObject(action));

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function dispatch(_x) {
    return _ref.apply(this, arguments);
  };
}();

var executeDispatch = function () {
  var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(action) {
    var result;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!_lodash2.default.isFunction(action)) {
              _context2.next = 5;
              break;
            }

            _context2.next = 3;
            return action(dispatch, getState);

          case 3:
            result = _context2.sent;
            return _context2.abrupt('return', Promise.resolve(result));

          case 5:

            error = new Error('provided action is not a thunk function');
            return _context2.abrupt('return', null);

          case 7:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function executeDispatch(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

exports.default = function (thunkFunction) {
  dispatches = [];
  error = undefined;
  state = undefined;
  originalState = undefined;

  function internalThunkCommands() {
    var _this = this;

    return {
      execute: function () {
        var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  if (!_lodash2.default.isFunction(thunkFunction)) {
                    _context3.next = 6;
                    break;
                  }

                  _context3.next = 3;
                  return executeDispatch(thunkFunction());

                case 3:
                  checkForStateMutation();
                  _context3.next = 7;
                  break;

                case 6:
                  error = new Error('you must pass a thunk function to Thunk()');

                case 7:
                  if (!error) {
                    _context3.next = 9;
                    break;
                  }

                  throw error;

                case 9:
                  return _context3.abrupt('return', dispatches);

                case 10:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, _this);
        }));

        return function execute() {
          return _ref3.apply(this, arguments);
        };
      }()
    };
  }

  return _extends({
    withState: function withState(storeState) {
      state = storeState;
      originalState = _lodash2.default.cloneDeep(storeState);
      return internalThunkCommands();
    }
  }, internalThunkCommands());
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _utils = require('./utils');

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var dispatches = [];
var state = void 0;
var originalState = void 0;
var error = void 0;

function createDispatchedObject(action) {
  return {
    isFunction: function isFunction() {
      return _lodash2.default.isFunction(action);
    },
    isPlainObject: function isPlainObject() {
      return _lodash2.default.isPlainObject(action);
    },
    getType: function getType() {
      return _lodash2.default.get(action, 'type');
    },
    getAction: function getAction() {
      return action;
    },
    getName: function getName() {
      return _lodash2.default.get(action, 'name');
    }
  };
}

function getState() {
  return state;
}

function checkForStateMutation() {
  var mutated = !utils.deepEqual(state, originalState);

  if (mutated) {
    error = new Error('state mutated after running the thunk');
  }
}